﻿Option Strict Off
Imports System
Imports Wisej.Web
Imports System.Threading
Imports System.Threading.Tasks
Imports Wisej.Core

Module Program

    ''' <summary>
    ''' The main entry point for the application.
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub Main()

        'get user email from token header put in Application.Session.UserEmail

        RunJavaScriptCode()

        ''Preferred Async approach - locks up when executing javascript
        'ProcessDataAsync()

        MessageBox.Show(Application.Session.UserEmail) 'confirm

        'CompleteAuthentication

        Application.MainPage = New Page1()


    End Sub

    Public Sub RunJavaScriptCode()
        Try
            Application.Eval("
            var req = new qx.io.remote.Request('https://designportalalex.azurewebsites.net/.auth/me', 'GET', 'text/plain');

            req.addListener('completed', function(e) {
            alert(e.getContent());
                var response = e.getContent();
                App.GetToken(response);
                });
            // Send request
            req.send();
            ")
        Catch ex As Exception
            Console.WriteLine($"Error during interact authentication: {ex.Message}")

        End Try

    End Sub

    Private Async Sub ProcessDataAsync()
        Dim task As Task(Of Boolean) = RunJavaScriptCodeAsync()
        task.Wait()

        Dim success = Await task

    End Sub

    Private Async Function RunJavaScriptCodeAsync() As Task(Of Boolean)
        Try
            Await Application.EvalAsync("
            var req = new qx.io.remote.Request('https://designportalalex.azurewebsites.net/.auth/me', 'GET', 'text/plain');

            req.addListener('completed', function(e) {
                var response = e.getContent();
                App.GetToken(response);
                });
            // Send request
            req.send();
        ")

        Catch ex As Exception
            Console.WriteLine($"Error during interact authentication: {ex.Message}")
            Return False
        End Try

        Return True

    End Function

    <WebMethod>
    Private Sub GetToken(T As String) 'method confirmed with test data
        Dim SearchWithinThis As String = T
        MessageBox.Show(T, "GetToken")
        Dim SearchForThis As String = "emails"
        Dim FirstCharacter As Integer = SearchWithinThis.IndexOf(SearchForThis) + 16
        SearchForThis = "B2C_1_signup_signin"
        Dim LastCharacter As Integer = SearchWithinThis.IndexOf(SearchForThis) - 23
        Dim Length As Int16 = ((Len(T) - FirstCharacter) - (Len(T) - LastCharacter)) + 1
        Application.Session.UserEmail = Strings.Mid(T, FirstCharacter, Length)

    End Sub
    ' ''' <summary>
    ' ''' You can use the entry method below
    ' ''' to receive the parameters from the URL in the args collection.
    ' ''' </summary>
    ' ''' <param name="args"></param>
    ' ''' <remarks></remarks>
    'Public Sub Main(args As NameValueCollection)

    'End Sub

End Module